Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/variable.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5600)
@@ -264,83 +431,104 @@
    END TYPE TVAR
 
-   TYPE(TVAR), DIMENSION(:), ALLOCATABLE :: tg_varextra !< table of variable structure with extra information.
+   TYPE(TVAR), DIMENSION(:), ALLOCATABLE :: tg_varextra !< array of variable structure with extra information.
                                                         !< fill when running var_def_extra() 
 
+   INTERFACE var_init
+      MODULE PROCEDURE var__init       ! initialize variable structure without array of value
+      MODULE PROCEDURE var__init_dp    ! initialize variable structure with real(8) 4D array of value
+      MODULE PROCEDURE var__init_1D_dp ! initialize variable structure with real(8) 1D array of value
+      MODULE PROCEDURE var__init_2D_dp ! initialize variable structure with real(8) 2D array of value
+      MODULE PROCEDURE var__init_3D_dp ! initialize variable structure with real(8) 3D array of value
+      MODULE PROCEDURE var__init_sp    ! initialize variable structure with real(4) 4D array of value
+      MODULE PROCEDURE var__init_1D_sp ! initialize variable structure with real(4) 1D array of value
+      MODULE PROCEDURE var__init_2D_sp ! initialize variable structure with real(4) 2D array of value
+      MODULE PROCEDURE var__init_3D_sp ! initialize variable structure with real(4) 3D array of value
+      MODULE PROCEDURE var__init_i1    ! initialize variable structure with integer(1) 4D array of value
+      MODULE PROCEDURE var__init_1D_i1 ! initialize variable structure with integer(1) 1D array of value
+      MODULE PROCEDURE var__init_2D_i1 ! initialize variable structure with integer(1) 2D array of value
+      MODULE PROCEDURE var__init_3D_i1 ! initialize variable structure with integer(1) 3D array of value
+      MODULE PROCEDURE var__init_i2    ! initialize variable structure with integer(2) 4D array of value
+      MODULE PROCEDURE var__init_1D_i2 ! initialize variable structure with integer(2) 1D array of value
+      MODULE PROCEDURE var__init_2D_i2 ! initialize variable structure with integer(2) 2D array of value
+      MODULE PROCEDURE var__init_3D_i2 ! initialize variable structure with integer(2) 3D array of value
+      MODULE PROCEDURE var__init_i4    ! initialize variable structure with integer(4) 4D array of value
+      MODULE PROCEDURE var__init_1D_i4 ! initialize variable structure with integer(4) 1D array of value
+      MODULE PROCEDURE var__init_2D_i4 ! initialize variable structure with integer(4) 2D array of value
+      MODULE PROCEDURE var__init_3D_i4 ! initialize variable structure with integer(4) 3D array of value
+      MODULE PROCEDURE var__init_i8    ! initialize variable structure with integer(8) 4D array of value
+      MODULE PROCEDURE var__init_1D_i8 ! initialize variable structure with integer(8) 1D array of value
+      MODULE PROCEDURE var__init_2D_i8 ! initialize variable structure with integer(8) 2D array of value
+      MODULE PROCEDURE var__init_3D_i8 ! initialize variable structure with integer(8) 3D array of value
+   END INTERFACE var_init
+
+   INTERFACE var_print
+      MODULE PROCEDURE var__print_unit ! print information on one variable
+      MODULE PROCEDURE var__print_arr  ! print information on a array of variables
+   END INTERFACE var_print
+   
+   INTERFACE var_clean
+      MODULE PROCEDURE var__clean_unit   
+      MODULE PROCEDURE var__clean_arr_1D    
+      MODULE PROCEDURE var__clean_arr_2D    
+      MODULE PROCEDURE var__clean_arr_3D    
+   END INTERFACE
+
    INTERFACE var_add_value
-      MODULE PROCEDURE var__add_value_dp  ! add table of value real(8) in variable structure
-      MODULE PROCEDURE var__add_value_rp  ! add table of value real(4) in variable structure
-      MODULE PROCEDURE var__add_value_i1  ! add table of value integer(1) in variable structure
-      MODULE PROCEDURE var__add_value_i2  ! add table of value integer(2) in variable structure
-      MODULE PROCEDURE var__add_value_i4  ! add table of value integer(4) in variable structure
-      MODULE PROCEDURE var__add_value_i8  ! add table of value integer(8) in variable structure
+      MODULE PROCEDURE var__add_value_dp  ! add array of value real(8) in variable structure
+      MODULE PROCEDURE var__add_value_rp  ! add array of value real(4) in variable structure
+      MODULE PROCEDURE var__add_value_i1  ! add array of value integer(1) in variable structure
+      MODULE PROCEDURE var__add_value_i2  ! add array of value integer(2) in variable structure
+      MODULE PROCEDURE var__add_value_i4  ! add array of value integer(4) in variable structure
+      MODULE PROCEDURE var__add_value_i8  ! add array of value integer(8) in variable structure
    END INTERFACE var_add_value
 
-   INTERFACE var_init
-      MODULE PROCEDURE var__init       ! initialse variable structure without table of value
-      MODULE PROCEDURE var__init_dp    ! initialse variable structure with real(8) 4D table of value
-      MODULE PROCEDURE var__init_1D_dp ! initialse variable structure with real(8) 1D table of value
-      MODULE PROCEDURE var__init_2D_dp ! initialse variable structure with real(8) 2D table of value
-      MODULE PROCEDURE var__init_3D_dp ! initialse variable structure with real(8) 3D table of value
-      MODULE PROCEDURE var__init_sp    ! initialse variable structure with real(4) 4D table of value
-      MODULE PROCEDURE var__init_1D_sp ! initialse variable structure with real(4) 1D table of value
-      MODULE PROCEDURE var__init_2D_sp ! initialse variable structure with real(4) 2D table of value
-      MODULE PROCEDURE var__init_3D_sp ! initialse variable structure with real(4) 3D table of value
-      MODULE PROCEDURE var__init_i1    ! initialse variable structure with integer(1) 4D table of value
-      MODULE PROCEDURE var__init_1D_i1 ! initialse variable structure with integer(1) 1D table of value
-      MODULE PROCEDURE var__init_2D_i1 ! initialse variable structure with integer(1) 2D table of value
-      MODULE PROCEDURE var__init_3D_i1 ! initialse variable structure with integer(1) 3D table of value
-      MODULE PROCEDURE var__init_i2    ! initialse variable structure with integer(2) 4D table of value
-      MODULE PROCEDURE var__init_1D_i2 ! initialse variable structure with integer(2) 1D table of value
-      MODULE PROCEDURE var__init_2D_i2 ! initialse variable structure with integer(2) 2D table of value
-      MODULE PROCEDURE var__init_3D_i2 ! initialse variable structure with integer(2) 3D table of value
-      MODULE PROCEDURE var__init_i4    ! initialse variable structure with integer(4) 4D table of value
-      MODULE PROCEDURE var__init_1D_i4 ! initialse variable structure with integer(4) 1D table of value
-      MODULE PROCEDURE var__init_2D_i4 ! initialse variable structure with integer(4) 2D table of value
-      MODULE PROCEDURE var__init_3D_i4 ! initialse variable structure with integer(4) 3D table of value
-      MODULE PROCEDURE var__init_i8    ! initialse variable structure with integer(8) 4D table of value
-      MODULE PROCEDURE var__init_1D_i8 ! initialse variable structure with integer(8) 1D table of value
-      MODULE PROCEDURE var__init_2D_i8 ! initialse variable structure with integer(8) 2D table of value
-      MODULE PROCEDURE var__init_3D_i8 ! initialse variable structure with integer(8) 3D table of value
-   END INTERFACE var_init
+   INTERFACE var_add_att
+      MODULE PROCEDURE var__add_att_unit ! add one attribute structure in variable structure
+      MODULE PROCEDURE var__add_att_arr  ! add a array of attribute structure in variable structure
+   END INTERFACE var_add_att
+
+   INTERFACE var_del_att               ! delete one attribute in variable structure
+      MODULE PROCEDURE var__del_att_name ! - given attribute name
+      MODULE PROCEDURE var__del_att_str  ! - given attribute structure
+   END INTERFACE var_del_att
 
    INTERFACE var_add_dim
       MODULE PROCEDURE var__add_dim_unit ! add one dimension structure in variable structure
-      MODULE PROCEDURE var__add_dim_tab  ! add a table of dimension structure in variable structure
+      MODULE PROCEDURE var__add_dim_arr  ! add a array of dimension structure in variable structure
    END INTERFACE var_add_dim
 
-   INTERFACE var_add_att
-      MODULE PROCEDURE var__add_att_unit ! add one attribute structure in variable structure
-      MODULE PROCEDURE var__add_att_tab  ! add a table of attribute structure in variable structure
-   END INTERFACE var_add_att
-
-   INTERFACE ASSIGNMENT(=)
+   INTERFACE var_copy
       MODULE PROCEDURE var__copy_unit   ! copy variable structure
-      MODULE PROCEDURE var__copy_tab    ! copy variable structure
+      MODULE PROCEDURE var__copy_arr    ! copy variable structure
    END INTERFACE
 CONTAINS
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine copy variable structure in another variable
-   !> structure
+   !> This subroutine copy variable structure in another one
    !> @details 
-   !> variable value are copied in a temporary table, so input and output
+   !> variable value are copied in a temporary array, so input and output
    !> variable structure value do not point on the same "memory cell", and so
    !> are independant. 
    !>
+   !> @warning do not use on the output of a function who create or read an
+   !> structure (ex: tl_var=var_copy(var_init()) is forbidden).
+   !> This will create memory leaks.
    !> @warning to avoid infinite loop, do not use any function inside 
    !> this subroutine
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[out] td_var1  : variable structure
-   !> @param[in] td_var2  : variable structure
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var__copy_unit( td_var1, td_var2 )
+   !> - November, 2013- Initial Version
+   !> @date November, 2014
+   !> - use function instead of overload assignment operator (to avoid memory leak)
+   !
+   !> @param[in] td_var   variable structure
+   !> @return copy of input variable structure
+   !-------------------------------------------------------------------
+   FUNCTION var__copy_unit( td_var )
       IMPLICIT NONE
       ! Argument
-      TYPE(TVAR), INTENT(OUT) :: td_var1
-      TYPE(TVAR), INTENT(IN)  :: td_var2
+      TYPE(TVAR), INTENT(IN) :: td_var
+      ! function
+      TYPE(TVAR) :: var__copy_unit
 
       ! local variable
@@ -353,97 +541,104 @@
 
       ! copy variable name, id, ..
-      td_var1%c_name     = TRIM(td_var2%c_name)
-      td_var1%c_point    = TRIM(td_var2%c_point)
-      td_var1%i_id       = td_var2%i_id
-      td_var1%i_ew       = td_var2%i_ew
-
-      td_var1%d_min      = td_var2%d_min
-      td_var1%d_max      = td_var2%d_max
-
-      td_var1%i_type     = td_var2%i_type
-      td_var1%i_natt     = td_var2%i_natt
-      td_var1%i_ndim     = td_var2%i_ndim
-      td_var1%i_ndim     = td_var2%i_ndim
+      var__copy_unit%c_name     = TRIM(td_var%c_name)
+      var__copy_unit%c_point    = TRIM(td_var%c_point)
+      var__copy_unit%i_id       = td_var%i_id
+      var__copy_unit%i_ew       = td_var%i_ew
+
+      var__copy_unit%d_min      = td_var%d_min
+      var__copy_unit%d_max      = td_var%d_max
+
+      var__copy_unit%i_type     = td_var%i_type
+      var__copy_unit%i_natt     = td_var%i_natt
+      var__copy_unit%i_ndim     = td_var%i_ndim
+      var__copy_unit%i_ndim     = td_var%i_ndim
 
       ! copy dimension
-      td_var1%t_dim(:)   = td_var2%t_dim(:)
+      var__copy_unit%t_dim(:)   = dim_copy(td_var%t_dim(:))
 
       ! copy attribute
-      IF( ASSOCIATED(td_var1%t_att) ) DEALLOCATE(td_var1%t_att)
-      IF( ASSOCIATED(td_var2%t_att) .AND. td_var1%i_natt > 0 )THEN
-         ALLOCATE( td_var1%t_att(td_var1%i_natt) )
-         DO ji=1,td_var1%i_natt
-            tl_att=td_var2%t_att(ji)
-            td_var1%t_att(ji)=tl_att
+      IF( ASSOCIATED(var__copy_unit%t_att) )THEN
+         CALL att_clean( var__copy_unit%t_att(:) )
+         DEALLOCATE(var__copy_unit%t_att)
+      ENDIF
+      IF( ASSOCIATED(td_var%t_att) .AND. var__copy_unit%i_natt > 0 )THEN
+         ALLOCATE( var__copy_unit%t_att(var__copy_unit%i_natt) )
+         DO ji=1,var__copy_unit%i_natt
+            tl_att=att_copy(td_var%t_att(ji))
+            var__copy_unit%t_att(ji)=att_copy(tl_att)
          ENDDO
+         ! clean
+         CALL att_clean(tl_att)
       ENDIF
 
       ! copy highlight attribute
-      td_var1%c_stdname  = TRIM(td_var2%c_stdname)
-      td_var1%c_longname = TRIM(td_var2%c_longname)
-      td_var1%c_units    = TRIM(td_var2%c_units)
-      td_var1%c_axis     = TRIM(td_var2%c_axis)
-      td_var1%d_scf      = td_var2%d_scf
-      td_var1%d_ofs      = td_var2%d_ofs
-      td_var1%d_fill     = td_var2%d_fill
+      var__copy_unit%c_stdname  = TRIM(td_var%c_stdname)
+      var__copy_unit%c_longname = TRIM(td_var%c_longname)
+      var__copy_unit%c_units    = TRIM(td_var%c_units)
+      var__copy_unit%c_axis     = TRIM(td_var%c_axis)
+      var__copy_unit%d_scf      = td_var%d_scf
+      var__copy_unit%d_ofs      = td_var%d_ofs
+      var__copy_unit%d_fill     = td_var%d_fill
       
       ! copy netcdf4 variable
-      td_var1%l_contiguous  = td_var2%l_contiguous
-      td_var1%l_shuffle     = td_var2%l_shuffle
-      td_var1%l_fletcher32  = td_var2%l_fletcher32 
-      td_var1%i_deflvl      = td_var2%i_deflvl
-      td_var1%i_chunksz(:)  = td_var2%i_chunksz(:)
+      var__copy_unit%l_contiguous  = td_var%l_contiguous
+      var__copy_unit%l_shuffle     = td_var%l_shuffle
+      var__copy_unit%l_fletcher32  = td_var%l_fletcher32 
+      var__copy_unit%i_deflvl      = td_var%i_deflvl
+      var__copy_unit%i_chunksz(:)  = td_var%i_chunksz(:)
       
       ! copy dimg variable
-      td_var1%i_rec = td_var2%i_rec
+      var__copy_unit%i_rec = td_var%i_rec
 
       ! copy pointer in an independant variable
-      IF( ASSOCIATED(td_var1%d_value) ) DEALLOCATE(td_var1%d_value)
-      IF( ASSOCIATED(td_var2%d_value) )THEN
-         ALLOCATE( dl_value( td_var2%t_dim(1)%i_len, &
-         &                   td_var2%t_dim(2)%i_len, &
-         &                   td_var2%t_dim(3)%i_len, &
-         &                   td_var2%t_dim(4)%i_len ) )
-         dl_value(:,:,:,:)=td_var2%d_value(:,:,:,:)
-
-         ALLOCATE( td_var1%d_value( td_var1%t_dim(1)%i_len, &
-         &                          td_var1%t_dim(2)%i_len, &
-         &                          td_var1%t_dim(3)%i_len, &
-         &                          td_var1%t_dim(4)%i_len ) )
-         td_var1%d_value(:,:,:,:)=dl_value(:,:,:,:)
+      IF( ASSOCIATED(var__copy_unit%d_value) ) DEALLOCATE(var__copy_unit%d_value)
+      IF( ASSOCIATED(td_var%d_value) )THEN
+         ALLOCATE( dl_value( td_var%t_dim(1)%i_len, &
+         &                   td_var%t_dim(2)%i_len, &
+         &                   td_var%t_dim(3)%i_len, &
+         &                   td_var%t_dim(4)%i_len ) )
+         dl_value(:,:,:,:)=td_var%d_value(:,:,:,:)
+
+         ALLOCATE( var__copy_unit%d_value( var__copy_unit%t_dim(1)%i_len, &
+         &                          var__copy_unit%t_dim(2)%i_len, &
+         &                          var__copy_unit%t_dim(3)%i_len, &
+         &                          var__copy_unit%t_dim(4)%i_len ) )
+         var__copy_unit%d_value(:,:,:,:)=dl_value(:,:,:,:)
 
          DEALLOCATE( dl_value )
       ENDIF
 
-      td_var1%c_interp(:)=td_var2%c_interp(:)
-      td_var1%c_extrap(:)=td_var2%c_extrap(:)
-      td_var1%c_filter(:)=td_var2%c_filter(:)
-
-   END SUBROUTINE var__copy_unit
-   !> @endcode
+      var__copy_unit%c_interp(:)=td_var%c_interp(:)
+      var__copy_unit%c_extrap(:)=td_var%c_extrap(:)
+      var__copy_unit%c_filter(:)=td_var%c_filter(:)
+
+   END FUNCTION var__copy_unit
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine copy variable structure in another variable
-   !> structure
+   !> This subroutine copy a array of variable structure in another one
    !> @details 
-   !> variable value are copied in a temporary table, so input and output
-   !> variable structure value do not point on the same "memory cell", and so
-   !> are independant. 
-   !>
+   !> see var__copy_unit
+   !>
+   !> @warning do not use on the output of a function who create or read an
+   !> structure (ex: tl_var=var_copy(var_init()) is forbidden).
+   !> This will create memory leaks.
    !> @warning to avoid infinite loop, do not use any function inside 
    !> this subroutine
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[out] td_var1  : variable structure
-   !> @param[in] td_var2  : variable structure
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var__copy_tab( td_var1, td_var2 )
+   !> - November, 2013- Initial Version
+   !> @date November, 2014
+   !> - use function instead of overload assignment operator 
+   !> (to avoid memory leak)
+   !
+   !> @param[in] td_var   array of variable structure
+   !> @return copy of input array of variable structure
+   !-------------------------------------------------------------------
+   FUNCTION var__copy_arr( td_var )
       IMPLICIT NONE
       ! Argument
-      TYPE(TVAR), DIMENSION(:), INTENT(IN   )  :: td_var2
-      TYPE(TVAR), DIMENSION(:), INTENT(  OUT) :: td_var1
+      TYPE(TVAR), DIMENSION(:), INTENT(IN   ) :: td_var
+      ! function
+      TYPE(TVAR), DIMENSION(SIZE(td_var(:))) :: var__copy_arr
 
       ! local variable
@@ -452,24 +647,18 @@
       !----------------------------------------------------------------
 
-      IF( SIZE(td_var2(:))/=SIZE(td_var1(:)) )THEN
-         CALL logger_error("VAR COPY: variable structure dimension differ")
-      ELSE
-         DO ji=1,SIZE(td_var2(:))
-            td_var1(ji)=td_var2(ji)
-         ENDDO
-      ENDIF
-
-   END SUBROUTINE var__copy_tab
-   !> @endcode
+      DO ji=1,SIZE(td_var(:))
+         var__copy_arr(ji)=var_copy(td_var(ji))
+      ENDDO
+
+   END FUNCTION var__copy_arr
    !-------------------------------------------------------------------
    !> @brief This subroutine clean variable structure
-   !
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var : variable strucutre
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var_clean( td_var )
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[inout] td_var variable strucutre
+   !-------------------------------------------------------------------
+   SUBROUTINE var__clean_unit( td_var )
       IMPLICIT NONE
       ! Argument
@@ -480,25 +669,15 @@
 
       ! loop indices
-      INTEGER(i4) :: ji
       !----------------------------------------------------------------
-
-      CALL logger_info( &
-      &  " CLEAN: reset variable "//TRIM(td_var%c_name) )
 
       ! del attribute
       IF( ASSOCIATED(td_var%t_att) )THEN
-         ! clean each attribute
-         DO ji=td_var%i_natt,1,-1
-            CALL att_clean(td_var%t_att(ji) )
-         ENDDO
-         DEALLOCATE( td_var%t_att )
+         CALL att_clean( td_var%t_att(:) )
+         DEALLOCATE(td_var%t_att)
       ENDIF
 
       ! del dimension
       IF( td_var%i_ndim /= 0 )THEN
-         ! clean each dimension
-         DO ji=td_var%i_ndim,1,-1
-            CALL dim_clean(td_var%t_dim(ji))
-         ENDDO
+         CALL dim_clean(td_var%t_dim(:))
       ENDIF
 
@@ -509,42 +688,151 @@
 
       ! replace by empty structure
-      td_var=tl_var
-
-   END SUBROUTINE var_clean
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !
-   !> @details 
+      td_var=var_copy(tl_var)
+
+   END SUBROUTINE var__clean_unit
+   !-------------------------------------------------------------------
+   !> @brief This subroutine clean 1D array of variable structure
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : table of dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] dd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !> @param[in] cd_interp  : interpolation method
-   !> @param[in] cd_extrap  : extrapolation method
-   !> @param[in] cd_filter  : filter method
-   !-------------------------------------------------------------------
-   !> @code
+   !> - September, 2014- Initial Version
+   !
+   !> @param[inout] td_var array of variable strucutre
+   !-------------------------------------------------------------------
+   SUBROUTINE var__clean_arr_1D( td_var )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TVAR), DIMENSION(:), INTENT(INOUT) :: td_var
+
+      ! local variable
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+
+      DO ji=SIZE(td_var(:)),1,-1
+         CALL var_clean(td_var(ji))
+      ENDDO
+
+   END SUBROUTINE var__clean_arr_1D
+   !-------------------------------------------------------------------
+   !> @brief This subroutine clean 2D array of variable structure
+   !
+   !> @author J.Paul
+   !> - September, 2014- Initial Version
+   !
+   !> @param[inout] td_var array of variable strucutre
+   !-------------------------------------------------------------------
+   SUBROUTINE var__clean_arr_2D( td_var )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TVAR), DIMENSION(:,:), INTENT(INOUT) :: td_var
+
+      ! local variable
+      ! loop indices
+      INTEGER(i4) :: ji
+      INTEGER(i4) :: jj
+      !----------------------------------------------------------------
+
+      DO jj=SIZE(td_var(:,:),DIM=2),1,-1
+         DO ji=SIZE(td_var(:,:),DIM=1),1,-1
+            CALL var_clean(td_var(ji,jj))
+         ENDDO
+      ENDDO
+
+   END SUBROUTINE var__clean_arr_2D
+   !-------------------------------------------------------------------
+   !> @brief This subroutine clean 3D array of variable structure
+   !
+   !> @author J.Paul
+   !> - September, 2014- Initial Version
+   !
+   !> @param[inout] td_var array of variable strucutre
+   !-------------------------------------------------------------------
+   SUBROUTINE var__clean_arr_3D( td_var )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TVAR), DIMENSION(:,:,:), INTENT(INOUT) :: td_var
+
+      ! local variable
+      ! loop indices
+      INTEGER(i4) :: ji
+      INTEGER(i4) :: jj
+      INTEGER(i4) :: jk
+      !----------------------------------------------------------------
+
+      DO jk=SIZE(td_var(:,:,:),DIM=3),1,-1
+         DO jj=SIZE(td_var(:,:,:),DIM=2),1,-1
+            DO ji=SIZE(td_var(:,:,:),DIM=1),1,-1
+               CALL var_clean(td_var(ji,jj,jk))
+            ENDDO
+         ENDDO
+      ENDDO
+
+   END SUBROUTINE var__clean_arr_3D
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure, given variable name.
+   !
+   !> @details
+   !> Optionally you could add 1D,2D,3D or 4D array of value, 
+   !> see var__init_1D_dp, var__init_2D_dp... for more information.
+   !>
+   !> you could also add more information with the following optional arguments:
+   !>   - id_type :  integer(4) variable type, (as defined by NETCDF type constants).
+   !>   - td_dim : array of dimension structure.
+   !>   - td_att  : array of attribute structure.
+   !>   - dd_fill : real(8) variable FillValue. if none NETCDF FillValue will be used.
+   !>   - cd_units : string character of units.
+   !>   - cd_axis : string character of axis expected to be used
+   !>   - cd_stdname : string character of variable standard name.
+   !>   - cd_longname : string character of variable long name.
+   !>   - cd_point : one character for ARAKAWA C-grid point name (T,U,V,F).
+   !>   - id_id : variable id (read from a file).
+   !>   - id_ew : number of point composing east west wrap band.
+   !>   - dd_scf : real(8) value for scale factor attribute.
+   !>   - dd_ofs : real(8) value for add offset attribute.
+   !>   - id_rec : record id (for rstdimg file).
+   !>   - dd_min : real(8) value for minimum value.
+   !>   - dd_max : real(8) value for maximum value.
+   !>   - ld_contiguous : use contiguous storage or not (for netcdf4).
+   !>   - ld_shuffle :  shuffle filter is turned on or not (for netcdf4).
+   !>   - ld_fletcher32 : fletcher32 filter is turned on or not (for netcdf4).
+   !>   - id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use (for netcdf4).
+   !>   - id_chunksz : chunk size (for netcdf4).
+   !>   - cd_interp  : a array of character defining interpolation method.
+   !>   - cd_extrap  : a array of character defining extrapolation method.
+   !>   - cd_filter  : a array of character defining filtering method.
+   !>
+   !>  @note most of these optionals arguments will be inform automatically,
+   !>  when reading variable from a file, or using confiuguration file variable.cfg.
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[in] cd_name         variable name
+   !> @param[in] id_type         variable type 
+   !> @param[in] td_dim          array of dimension structure
+   !> @param[in] td_att          array of attribute structure
+   !> @param[in] dd_fill         fill value
+   !> @param[in] cd_units        units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      variable standard name
+   !> @param[in] cd_longname     variable long name
+   !> @param[in] cd_point        point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           variable id
+   !> @param[in] id_ew           east west wrap
+   !> @param[in] dd_scf          scale factor
+   !> @param[in] dd_ofs          add offset
+   !> @param[in] id_rec          record id (for rstdimg file)
+   !> @param[in] dd_min          minimum value
+   !> @param[in] dd_max          maximum value
+   !> @param[in] ld_contiguous   use contiguous storage or not 
+   !> @param[in] ld_shuffle      shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       deflate level from 0 to 9, 0 indicates no deflation is in use
+   !> @param[in] id_chunksz      chunk size
+   !> @param[in] cd_interp       interpolation method
+   !> @param[in] cd_extrap       extrapolation method
+   !> @param[in] cd_filter       filter method
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init( cd_name, id_type, td_dim, &
    &                              td_att, dd_fill, cd_units, cd_axis, &
@@ -586,5 +874,5 @@
 
       ! local variable
-      INTEGER(i4) :: il_attid
+      INTEGER(i4) :: il_ind
 
       TYPE(TATT)  :: tl_att
@@ -637,14 +925,24 @@
       ! add _FillValue
       IF( PRESENT(dd_fill) )THEN
-         tl_att=att_init('_FillValue',dd_fill)
+         SELECT CASE( var__init%i_type )
+            CASE(NF90_BYTE)
+               tl_att=att_init('_FillValue', INT(dd_fill,i1) )
+            CASE(NF90_SHORT)
+               tl_att=att_init('_FillValue', INT(dd_fill,i2) )
+            CASE(NF90_INT)
+               tl_att=att_init('_FillValue', INT(dd_fill,i4) )
+            CASE(NF90_FLOAT)
+               tl_att=att_init('_FillValue', INT(dd_fill,sp) )
+            CASE DEFAULT ! NF90_DOUBLE
+                     tl_att=att_init('_FillValue', dd_fill )
+         END SELECT
          CALL var_move_att(var__init, tl_att)
       ELSE
-         il_attid=0
+         il_ind=0
          IF( ASSOCIATED(var__init%t_att) )THEN
-            il_attid=att_get_id(var__init%t_att(:),'_FillValue')
+            il_ind=att_get_index(var__init%t_att(:),'_FillValue')
          ENDIF
-         IF( il_attid == 0 )THEN
+         IF( il_ind == 0 )THEN
             SELECT CASE( var__init%i_type )
-
                CASE(NF90_BYTE)
                   tl_att=att_init('_FillValue',NF90_FILL_BYTE)
@@ -657,5 +955,4 @@
                CASE DEFAULT ! NF90_DOUBLE
                   tl_att=att_init('_FillValue',NF90_FILL_DOUBLE)
-
             END SELECT         
             CALL var_add_att(var__init, tl_att)
@@ -687,4 +984,6 @@
       IF( PRESENT(td_dim) )THEN
          CALL var_add_dim(var__init, td_dim(:))
+      ELSE
+         CALL var_add_dim(var__init, dim_fill_unused())
       ENDIF
 
@@ -703,4 +1002,5 @@
       ENDIF
 
+      ! netcdf4
       IF( PRESENT(ld_contiguous) )THEN
          var__init%l_contiguous=ld_contiguous
@@ -723,12 +1023,15 @@
       ENDIF
 
+      ! interp
       IF( PRESENT(cd_interp) )THEN
          var__init%c_interp(:)=cd_interp(:)
       ENDIF
 
+      !extrap
       IF( PRESENT(cd_extrap) )THEN
          var__init%c_extrap(:)=cd_extrap(:)
       ENDIF
 
+      !filter
       IF( PRESENT(cd_filter) )THEN
          var__init%c_filter(:)=cd_filter(:)
